"""
This type stub file was generated by pyright.
"""

from typing import Generic, TypeVar
from codegen.utils.codemod.codemod_writer_decorators import apidoc
from graph_sitter.core.detached_symbols.function_call import FunctionCall
from graph_sitter.core.expressions import Expression
from graph_sitter.core.interfaces.editable import Editable
from graph_sitter.core.interfaces.has_value import HasValue
from graph_sitter.core.interfaces.wrapper_expression import IWrapper
from graph_sitter.extensions.autocommit import reader

Parent = TypeVar("Parent", bound="Editable")
@apidoc
class AwaitExpression(Expression[Parent], HasValue, IWrapper, Generic[Parent]):
    """An awaited expression, only found in asynchronous context.

    Example:
        ```python
        await (get_db(user_id))
        ```
    """
    def __init__(self, ts_node, file_node_id, G, parent: Parent) -> None:
        ...
    
    @property
    @reader
    def function_calls(self) -> list[FunctionCall]:
        """Gets all function calls within the await expression.

        Returns a list of all function calls contained within the value/expression being awaited.

        Returns:
            list[FunctionCall]: A list of function call nodes contained within the await expression's value.
        """
        ...
    


