"""
This type stub file was generated by pyright.
"""

from functools import cached_property
from typing import Self, TypeVar
from codegen.utils.codemod.codemod_writer_decorators import apidoc
from graph_sitter.core.expressions import Expression
from graph_sitter.core.expressions.binary_expression import BinaryExpression
from graph_sitter.core.symbol_groups.expression_group import ExpressionGroup

Parent = TypeVar("Parent")
@apidoc
class ComparisonExpression(BinaryExpression):
    """Any comparison expression in the code.

    Includes all set of `<`, `<=`, `>`, `>=`, `==`, `!=` etc.
    """
    def __init__(self, ts_node, file_node_id, G, parent: Parent) -> None:
        ...
    
    @property
    def operators(self) -> list[ExpressionGroup[Expression[Self], Self]]:
        """Returns a list of operator expressions in a comparison expression.

        Extracts and groups the non-named operators (e.g., <, <=, >, >=, ==, !=) from the comparison expression's tree-sitter node.
        Each group of operators is wrapped in an ExpressionGroup.

        Returns:
            list[ExpressionGroup[Expression[Self], Self]]: A list of ExpressionGroups containing one or more expression operators that appear between the compared elements.
        """
        ...
    
    @cached_property
    def elements(self) -> list[Expression[Self]]:
        """Returns a list of expressions representing the named child nodes of the current node.

        This property returns each named child node of the current TreeSitter node as an Expression object.
        The nodes are parsed and transformed into their corresponding Expression types.

        Returns:
            list[Expression[Self]]: A list of Expression objects representing each named child node.
        """
        ...
    


