"""
This type stub file was generated by pyright.
"""

from abc import abstractmethod
from typing import TYPE_CHECKING
from graph_sitter.core.external.external_process import ExternalProcess
from graph_sitter.enums import ProgrammingLanguage
from graph_sitter.codebase.codebase_graph import CodebaseGraph

if TYPE_CHECKING:
    ...
class DependencyManager(ExternalProcess):
    """Manages dependencies for the given repository.

    Handles reading, installing, and managing any dependency-based operations.
    """
    @abstractmethod
    def parse_dependencies(self): # -> None:
        ...
    
    @abstractmethod
    def install_dependencies(self): # -> None:
        ...
    
    @abstractmethod
    def remove_dependencies(self): # -> None:
        ...
    


def get_dependency_manager(language: ProgrammingLanguage, codebase_graph: CodebaseGraph, enabled: bool = ...) -> DependencyManager | None:
    ...

