"""
This type stub file was generated by pyright.
"""

from abc import ABC

logger = ...
class ExternalProcess(ABC):
    """Base class for all additional extrnal services that require a separate process.

    Examples include language engines, dependency managers, etc.

    Attributes:
        repo_path (str): Path to the repository root directory
        base_path (str | None): Optional subdirectory path within the repo to analyze
        full_path (str): Complete path combining repo_path and base_path
        is_ready (bool): Whether the engine has completed initialization and is ready
        error (BaseException | None): Whether the engine encountered an error during startup
    """
    repo_path: str
    base_path: str | None
    full_path: str
    is_ready: bool
    _error: BaseException | None
    def __init__(self, repo_path: str, base_path: str | None = ...) -> None:
        ...
    
    def start(self, async_start: bool = ...): # -> None:
        ...
    
    def reparse(self, async_start: bool = ...): # -> None:
        ...
    
    def ready(self) -> bool:
        ...
    
    def error(self) -> BaseException | None:
        ...
    
    def wait_until_ready(self, ignore_error: bool = ...): # -> None:
        ...
    


