"""
This type stub file was generated by pyright.
"""

from typing import Generic, TypeVar
from codegen.utils.codemod.codemod_writer_decorators import py_apidoc
from graph_sitter.core.interfaces.editable import Editable
from graph_sitter.core.placeholder.placeholder import Placeholder

Parent = TypeVar("Parent", bound="Editable")
@py_apidoc
class PyReturnTypePlaceholder(Placeholder[Parent], Generic[Parent]):
    """A placeholder for a python return type that does not exist.
    Can be populated using the `edit` method.
    """
    def edit(self, new_src: str, fix_indentation: bool = ..., priority: int = ..., dedupe: bool = ...) -> None:
        """Edits or creates a return type annotation for a method or function.

        Used to modify or create a return type annotation in Python functions and methods. If the new source is not empty,
        it will be appended after the parameters with the ' -> ' prefix.

        Args:
            new_src (str): The new return type annotation text to be added.
            fix_indentation (bool, optional): Whether to fix the indentation of the new source. Defaults to False.
            priority (int, optional): Priority of the edit operation. Defaults to 0.
            dedupe (bool, optional): Whether to deduplicate the edit operation. Defaults to True.

        Returns:
            None
        """
        ...
    


